-- 0. length n
myLength2 = foldr addOne 0
 where addOne _ s = s + 1

myLength = foldr (\ _ s -> s + 1) 0
myLength3 l = sum (map replaceWithOne l)
 where replaceWithOne _ = 1
myLength4 l = sum (map (\_ -> 1) l)

-- 1. prime n
prime n = length [ d | d <- [ 1 .. n ], mod n d == 0 ] == 2
prime1 n = null [ d | d <- [ 2 .. n-1 ], mod n d == 0 ]
prime2 n = null (filter isDivisor [ 2 .. n-1 ])
 where isDivisor d = mod n d == 0
prime3 n = null (filter (\d -> mod n d == 0) [2 .. n-1])

-- 2. countOccurrences n l - number of occurrences of n in l
countOccurrences :: (Eq a) => a -> [a] -> Int
countOccurrences n l = length [ x | x <- l, x == n ]
countOccurrences2 n = foldr (\h s -> if (h == n) then (s + 1) else s) 0
countOccurrences3 n l =  length (filter (==n) l)

-- 3. product of all unique numbers in l
productUnique :: [Int] -> Int
productUnique l = product [ x | x <- l, countOccurrences x l == 1]

-- 4. intersect & union
intersect l1 l2 = [ x | x <- l1, elem x l2 ]
union l1 l2 = [ x | x <- l1, not (elem x l2) ] ++ l2

-- 5. Find the sum of all minimal elements in a list of lists, which are positive

mySum = foldr (+) 0
myProduct = foldr (*) 1

myMin l = foldr min (head l) l
myMax l = foldr max (head l) l

